/* author: Louis Hugues - created on 19 janv. 2005  */
package simbad.gui;
import javax.vecmath.Color3f;
import javax.vecmath.Vector3d;
import javax.vecmath.Vector3f;

import simbad.sim.*;

/**
 *
 */
public class Test extends EnvironmentDescription{
    

    public class Robot extends Agent {

    
        public Robot(Vector3d position, String name) {
            super(position, name);
            //RobotFactory.addCameraSensor(this);
        }

        /** Initialize Agent's Behavior */
        public void initBehavior() {
            setTranslationalVelocity(0.5);
        }

       
        /** Perform one step of Agent's Behavior */
        public void performBehavior() {
           // if (collisionDetected()&& (! interactionDetected()))
           //     moveToStartPosition();
            if ((getCounter() % 80) == 0) {
                setRotationalVelocity(Math.PI / 2 * (0.5 - Math.random()));
                setTranslationalVelocity(0.5);
            }
            
        }
    }

    public Test() {
        showAxis(false);
        setUsePhysics(true);
        setWorldSize(12);
        boxColor = new Color3f(0.6f,0.5f,.3f);
        Box box  =new Box(new Vector3d(-5,0,0),new Vector3f(0.1f,1,10),this);
        
        
		add(box);
		add(new Box(new Vector3d(0,0,-5),new Vector3f(10,1,0.1f),this));
		add(new Box(new Vector3d(5,0,0),new Vector3f(0.1f,1,10),this));
		add(new Box(new Vector3d(0,0,5),new Vector3f(10,1,0.1f),this));
		
        add(new Robot(new Vector3d(0, 0, 0), "R1"));
       int n = 1;
       int i=1;
        float s = 0.0f;
        Color3f c ;
        for (int x = -n; x <= n; x++) {
            for (int z = -n; z <= n; z++) {
                SimpleAgent a;
                if (!((x == 0) && (z == 0))) {
                    c =  new Color3f(x/(float)n, 0.3f, z/(float)n);
                    a = new BallAgent(new Vector3d(x, 5, z), "ball", c,0.50f,0.15f);
                    
                    
                    add(a);
                    i++;
                }
            }
        }
        
    }
    /** The simbad main. Process command line arguments and launch simbad.*/
    public static void main(String[] args) {

        //request antialising 
        System.setProperty("j3d.implicitAntialiasing", "true");

        Simbad frame = new Simbad(new Test() ,false);
    }


}
