package simbad.picoevo.ext.evolution;

import java.util.ArrayList;

import simbad.picoevo.core.*;
import simbad.picoevo.core.evolution.*;
import simbad.picoevo.core.representation.*;
import simbad.picoevo.ext.*;
import simbad.picoevo.ext.representation.*;
import simbad.picoevo.toolbox.*;


public class InitialisationOperator_Individual_DynamicArray_Bit extends InitialisationOperator_Individual {

	// ### Constructors ###
	
	public InitialisationOperator_Individual_DynamicArray_Bit () 
	{
		super();
	}
	
	public InitialisationOperator_Individual_DynamicArray_Bit (String __name) 
	{ 
		super(__name); 
	}
	
	// ### Methods ###

	public void initialise( Individual __o ) 
	{
		try {
			Individual_SimpleIndividual individual = (Individual_SimpleIndividual)__o;
	
			ArrayList OperatorList = new ArrayList();
			VariationOperator_Element_BitVector_UniformMutation op = new VariationOperator_Element_BitVector_UniformMutation("mutation1", ((ParameterSet_Evolution_mulambdaES)individual.getTemplate()).getMutationRate());
			OperatorList.add(op);
			individual.addElement(new Element_DynamicArray_Bit("bits vector", individual, OperatorList, ((ParameterSet_Evolution_mulambdaES)individual.getTemplate()).getGenomeSize()));
			((Element_DynamicArray_Bit)individual.getElementAt(0)).performInitialisation();
		}
		catch ( java.lang.ClassCastException e )
		{
			Display.error(""+this.getClass().getName()+"::initialise(.) - Class cast exception");
		}
	}


}
