/*
 * Created on 20 aot 2005
 *
 */

package simbad.picoevo.ext.evolution;

import simbad.picoevo.core.*;
import simbad.picoevo.core.evolution.*;
import simbad.picoevo.core.representation.*;
import simbad.picoevo.ext.*;
import simbad.picoevo.ext.representation.*;
import simbad.picoevo.toolbox.*;



public class VariationOperator_Element_Double_UniformMutation_ZeroOneInterval extends VariationOperator {
	
	VariationOperator_Element_Double_UniformMutation_ZeroOneInterval ( String __name )
	{
		super (__name);
	}
	
	VariationOperator_Element_Double_UniformMutation_ZeroOneInterval ( String __name, double __operatorRate )
	{
		super(__name,__operatorRate);
	}
	
	public void applyOperator ( EvolutionObject __element )
	{
		if ( __element.getClass() != Element_Double.class )
		{
			Display.error(""+this.getClass().getName()+"::applyOperator() - mismatch");
		}
		if ( Math.random() < this._operatorRate )
		{
			((Element_Double)__element).setValue(Math.random());
			//Display.info("!!!!Mutate!!!");
		}
	}

}
