/*
 * Author: nicolas.bredeche(@)lri.fr
 * Created on 9 sept. 2005
 * 
 */

package simbad.picoevo.ext.representation;

import simbad.picoevo.core.*;
import simbad.picoevo.core.evolution.*;
import simbad.picoevo.core.representation.*;
import simbad.picoevo.ext.*;
import simbad.picoevo.ext.evolution.*;
import simbad.picoevo.ext.representation.*;
import simbad.picoevo.toolbox.*;

/* this class extends Population (which is asbtract) - in the current setup, nothing must be done to use it */
public class Population_SimplePopulation extends Population {
	
	// ### Data ###
	
	EvolveOperator_Population_Generational _evolveOperator; 
	
	// ### Constructor(s) ###
	
	public Population_SimplePopulation ( String __populationName , World __evolutionSpace )
	{
		super ( __populationName, __evolutionSpace );
		this._evolveOperator = new EvolveOperator_Population_Generational("generational");
	}

	public void evolveOneStep( boolean __display ) 
	{
		this._evolveOperator.evolve(this,__display);
	}

	// ### Other methods ###
	
}
